<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>LocalizedHighlightedQuestionDataSource</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/operation/parameters/document/highlighted-question/components/localized-highlighted-question-list.component.ts</code>
        </p>


            <p class="comment">
                <h3>Extends</h3>
            </p>
            <p class="comment">
                    <code>DataSource</code>
            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#connect">connect</a>
                            </li>
                            <li>
                                <a href="#disconnect">disconnect</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(data: <a href="../interfaces/LocalizedHighlightedQuestion.html">LocalizedHighlightedQuestion[]</a>, sort: MatSort, translateService: TranslateService)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="58" class="link-to-prism">src/app/operation/parameters/document/highlighted-question/components/localized-highlighted-question-list.component.ts:58</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>data</td>
                                                  
                                                        <td>
                                                                    <code><a href="../interfaces/LocalizedHighlightedQuestion.html" target="_self" >LocalizedHighlightedQuestion[]</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>sort</td>
                                                  
                                                        <td>
                                                                    <code>MatSort</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>translateService</td>
                                                  
                                                        <td>
                                                                    <code>TranslateService</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>


            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="connect"></a>
                        <span class="name">
                            <b>
                            connect
                            </b>
                            <a href="#connect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>connect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="65" class="link-to-prism">src/app/operation/parameters/document/highlighted-question/components/localized-highlighted-question-list.component.ts:65</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code>Observable&lt;any[]&gt;</code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="disconnect"></a>
                        <span class="name">
                            <b>
                            disconnect
                            </b>
                            <a href="#disconnect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>disconnect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="77" class="link-to-prism">src/app/operation/parameters/document/highlighted-question/components/localized-highlighted-question-list.component.ts:77</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, EventEmitter, Input, Output, ViewChild } from &#x27;@angular/core&#x27;;
import { HighlightedQuestion, LocalizedHighlightedQuestion } from &#x27;../model/highlighted-question&#x27;;
import { DataSource } from &#x27;@angular/cdk/collections&#x27;;
import { MatSort } from &#x27;@angular/material&#x27;;
import { TranslateService } from &#x27;@ngx-translate/core&#x27;;
import { Observable } from &#x27;rxjs/Observable&#x27;;
import { merge } from &#x27;rxjs/observable/merge&#x27;;
import { of } from &#x27;rxjs/observable/of&#x27;;
import { map } from &#x27;rxjs/operators&#x27;;
import { sortOnProperty } from &#x27;../../../../../core/util/table-utils&#x27;;
import { HighlightedQuestionService } from &#x27;../services/highlighted-question.service&#x27;;
import { Operation } from &#x27;../../../../model/operation&#x27;;
import { FileService } from &#x27;../../../../../core/service/file-service/file-service&#x27;;

@Component({
  selector: &#x27;localized-highlighted-question-list&#x27;,
  templateUrl: &#x27;./localized-highlighted-question-list.component.html&#x27;,
  styleUrls: [&#x27;./localized-highlighted-question-list.component.scss&#x27;]
})
export class LocalizedHighlightedQuestionListComponent {
  @Input() editMode &#x3D; false;
  @Input() operation: Operation;
  @Output() onRemove &#x3D; new EventEmitter&lt;LocalizedHighlightedQuestion&gt;();
  @ViewChild(MatSort) sort: MatSort;
  empty &#x3D; true;
  dataSource;


  constructor(private translateService: TranslateService,
              private highlightedQuestionService: HighlightedQuestionService,
              private fileService: FileService) {
  }

  remove(element) {
    this.onRemove.emit(element);
  }

  download(e, element: LocalizedHighlightedQuestion) {
    this.highlightedQuestionService.download(this.operation.id, element.id).subscribe(blob &#x3D;&gt; {
      this.fileService.downloadBlob(element.fileName, blob)
    });
    e.preventDefault();
  }


  get displayedColumns(): string[] {
    return [&quot;localizedQuestion&quot;, &quot;language&quot;, &quot;fileName&quot;, &quot;date&quot;].concat(this.editMode ? [&quot;actions&quot;] : []);
  }

  @Input()
  set question(question: HighlightedQuestion) {
    this.empty &#x3D; question.localizedQuestions.length &#x3D;&#x3D; 0;
    this.dataSource &#x3D;
      new LocalizedHighlightedQuestionDataSource(question.localizedQuestions, this.sort, this.translateService);
  }
}

class LocalizedHighlightedQuestionDataSource extends DataSource&lt;any&gt; {
  constructor(private data: LocalizedHighlightedQuestion[],
              private sort: MatSort,
              private translateService: TranslateService) {
    super();
  }

  connect(): Observable&lt;any[]&gt; {
    return merge(of(this.data), this.sort.sortChange)
      .pipe(
        map(() &#x3D;&gt; this.data.map(
          question &#x3D;&gt; Object.assign({}, question, {
            language: this.translateService.instant(
              &#x60;parameters.highlighted-question.form.fields.language.label-key.${question.language}&#x60;)
          })
        )),
        map(translated &#x3D;&gt; sortOnProperty(translated, this.sort.active, this.sort.direction)));
  }

  disconnect() {
  }
}
</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'LocalizedHighlightedQuestionDataSource.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
